local BrohoofFrame = CreateFrame("Frame")
BrohoofFrame:RegisterEvent("ADDON_LOADED")

local BrohoofChatFrame = CreateFrame("Frame")
BrohoofFrame:RegisterEvent("CHAT_MSG_ADDON")

if not ReceiveBrohoofFrame then
   ReceiveBrohoofFrame = CreateFrame("Frame")
end

local function BrohoofHandler(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Brohoof" then
		hoof = C_ChatInfo.RegisterAddonMessagePrefix("BROHOOF")

		SlashCmdList["SENDBH"] = sendbrohoof_command;
			SLASH_SENDBH1 = "/bh"
			SLASH_SENDBH2 = "/hoof"
			SLASH_SENDBH3 = "/)"

			DEFAULT_CHAT_FRAME:AddMessage("|cFFD19FE3[Brohoof]|r v" .. GetAddOnMetadata("Brohoof", "Version") .. " loaded. To use, simply target someone and then use either |cFF00FFFF/bh|r, |cFF00FFFF/hoof|r or |cFF00FFFF/)|r to brohoof them!")
	end
end

local function BrohoofChatHandler(self, event, prefix, message, channel, sender)
	if event == "CHAT_MSG_ADDON" then
		if prefix == "BROHOOF" then
			local sendername, senderrealm = string.match(tostring(sender), "(.*)%-(.*)")
			local myrealm = GetRealmName()
			
			if senderrealm == myrealm then
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3E" .. sendername .. " brohoofed you.|r")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3E" .. sender .. " brohoofed you.|r")
			end
		end
	end

end

BrohoofFrame:SetScript("OnEvent", BrohoofHandler)
BrohoofChatFrame:SetScript("OnEvent", BrohoofChatHandler)

function sendbrohoof_command()
	if UnitName("target") == nil then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3EYou look around for someone you can brohoof.|r")
	else
		if UnitName("target") == UnitName("player") then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3EYou brohoof yourself. Why not?|r")
		else
			local isFriend = UnitIsFriend("player","target")
			local isPerson = UnitIsPlayer("target")
		
			if isPerson == false then
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3E" .. UnitName("target") .. " stares blankly at your offered brohoof.|r")
			elseif isPerson == true then
				if isFriend == false then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3EAfter some thought, you decide against offering a brohoof to the enemy.|r")
				elseif isFriend == true then
					local bro, brorealm = UnitName("target")

					if brorealm == nil then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3EYou brohoofed " .. bro .. ".|r")
						C_ChatInfo.SendAddonMessage("BROHOOF", "Friendship is Magic!", "WHISPER", bro)
					else
						local fullbroname = bro .. "-" .. brorealm
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7E3EYou brohoofed " .. fullbroname .. ".|r")
						C_ChatInfo.SendAddonMessage("BROHOOF", "Friendship is Magic!", "WHISPER", fullbroname)
					end
				end
			end
		end
	end
end